-- Created by NuclearTonic
-- If reusing this code, please keep the name of the original author listed
-- in respect for borrowing said authors code.
-- RESPECT!

import "Turbine";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Tonic.Utils.Class";
import "Tonic.UI.CheckBox";
import "Tonic.UI.ComboBox";
import "Tonic.UI.AutoListBox";
import "Tonic.UI.Window";
import "Tonic.UI.MenuUtils";

buttonWidth = 85;
selectionWidth = 160;
selectionHeight = 20;
insideBoxXOffset = selectionWidth + 5;
insideBoxYOffset = startFromTop + 200;

GeneralMenu = class( Tonic.UI.AutoListBox );

function GeneralMenu:Constructor()
	Tonic.UI.AutoListBox.Constructor( self );

	self.utils = Tonic.UI.MenuUtils();
	
	self.utils:AddLabelBox( self, "If you want to copy your bar locations from another character on this server you can perform that by selecting the characters name from the dropdown and selecting 'Copy Profile'.", selectionWidth + 250, selectionHeight + 30 );
	
	self:AddSettings();
	self:AddCommandsBar();
	self:AddItem( self.settingsBox );
end

function GeneralMenu:AddSettings()
	self.settingsBox = self.utils:AddAutoListBox( self, Turbine.UI.Orientation.Vertical, 0, 0, 0, 0 );

	self.utils:AddLabelBox( self, "Profiles:", selectionWidth + 100, selectionHeight );

	self.profileList = Tonic.UI.ComboBox();
	self.profileList:SetSize( 200, 20 );
	self.profileList:SetParent( self );
	self:AddItem( self.profileList );
	
	self.utils:AddLabelBox( self, "Copy Profile:", selectionWidth + 100, selectionHeight );

	local box1 = self.utils:AddAutoListBox( self, Turbine.UI.Orientation.Horizontal );	
	local noShortcutButton = Turbine.UI.Lotro.Button();
	noShortcutButton:SetText( "Without Shortcuts" );
	noShortcutButton:SetSize( buttonWidth + 75, selectionHeight );
	noShortcutButton.MouseClick = function( sender, args )
		local profile = self.profileList:GetSelection();
		if ( profile ~= nil ) then
			theSettingsManager:CopyProfile( profile, theSettingsManager.PARTIAL );
		end
	end
	box1:AddItem( noShortcutButton );

	local shortcutButton = Turbine.UI.Lotro.Button();
	shortcutButton:SetText( "With Shortcuts" );
	shortcutButton:SetSize( buttonWidth + 75, selectionHeight );
	shortcutButton.MouseClick = function( sender, args )
		local profile = self.profileList:GetSelection();
		if ( profile ~= nil ) then
			theSettingsManager:CopyProfile( profile, theSettingsManager.ALL );
		end
	end
	box1:AddItem( shortcutButton );
	self:AddItem( box1 );
	
	self.utils:AddLabelBox( self, "Display TonicBar's Goblet Launcher to show the MainMenu?", selectionWidth + 300, selectionHeight );
	self.displayGobletCheckbox = self.utils:AddCheckBox( self, "Display?", selectionWidth + 500, selectionHeight + 50 );
end

function GeneralMenu:AddCommandsBar()
end

function GeneralMenu:DisplaySettings( showQuickslots )
	self.settingsBox:SetVisible( showQuickslots );
	
	local theSettings = theSettingsManager:GetWrapperSettings();
	
	self.displayGobletCheckbox.CheckedCallback = function( sender, args )
		local settings = theSettingsManager:GetWrapperSettings();
		settings.visible = self.displayGobletCheckbox.IsChecked;
		theSettingsManager:SetWrapperSettings( settings );
	end
	self.displayGobletCheckbox:SetChecked( theSettings.visible );
end

function GeneralMenu:GetSelection()
	return nil;
end

function GeneralMenu:RefreshComboBox()
	local player = Turbine.Gameplay.LocalPlayer();
	self.profileList:Clear();
	for key, value in pairs (theSettingsManager:GetProfiles() ) do
		local found = false;
		if ( player:GetName() == key ) then
			found = true;
		end
		for i = 1, self.profileList:GetItemCount() do
			if ( self.profileList:GetItem(i) == key ) then
				found = true;
			end
		end
		if ( found == false ) then
			self.profileList:AddItem( key, key );
		end
	end
end